clc;clear;close;

eff5=load('eff_5per.mat');
eff5.data(2:length(eff5.data(:,1))+1,:) = eff5.data;
eff5.data(1,:) = [0,eff5.data(2,2)];
eff20=load('eff_20per.mat');
eff20.data(2:length(eff20.data(:,1))+1,:) = eff20.data;
eff20.data(1,:) = [0,eff20.data(2,2)];
eff25=load('eff_25per.mat');
eff25.data(2:length(eff25.data(:,1))+1,:) = eff25.data;
eff25.data(1,:) = [0,eff25.data(2,2)];
eff28=load('eff_28per.mat');
eff28.data(2:length(eff28.data(:,1))+1,:) = eff28.data;
eff28.data(1,:) = [0,eff28.data(2,2)];
eff30=load('eff_30per.mat');
eff30.data(2:length(eff30.data(:,1))+1,:) = eff30.data;
eff30.data(1,:) = [0,eff30.data(2,2)];
eff33=load('eff_33per.mat');
eff33.data(2:length(eff33.data(:,1))+1,:) = eff33.data;
eff33.data(1,:) = [0,eff33.data(2,2)];
eff35=load('eff_35per.mat');
eff35.data(2:length(eff35.data(:,1))+1,:) = eff35.data;
eff35.data(1,:) = [0,eff35.data(2,2)];


eng_eff_map = [[eff5.data,ones(size(eff5.data(:,1)))*5];
                [eff20.data,ones(size(eff20.data(:,1)))*20];
                [eff25.data,ones(size(eff25.data(:,1)))*25];
                [eff28.data,ones(size(eff28.data(:,1)))*28];
                [eff30.data,ones(size(eff30.data(:,1)))*30];
                [eff33.data,ones(size(eff33.data(:,1)))*33];
                [eff35.data,ones(size(eff35.data(:,1)))*35]];
speed=eng_eff_map(:,1);torque=eng_eff_map(:,2);eff=eng_eff_map(:,3); 
EFF = TriScatteredInterp(speed,torque,eff,'linear');
clip=0;
[SPEED,TORQUE]=meshgrid(min(speed)+clip:1:max(speed)-clip,min(torque)+clip:1:max(torque)-clip);
EFFnew = EFF(SPEED,TORQUE);
surf(SPEED,TORQUE,EFFnew,'FaceColor','interp','EdgeColor','interp','FaceLighting','phong');
hold on;
plot3(speed,torque,eff,'o');

save('eng_map.mat','EFFnew','SPEED','TORQUE');