
function [v_hwy, v_us06, v_udds] = loadProfiles(fileNames)
global MPH2mps
% The three speed profiles of interest are loaded
v_hwy = load(fileNames{1});
v_us06 = load(fileNames{2});
v_udds = load(fileNames{3});
% Speeds are converted from MPH to mps
v_hwy(:,2) = v_hwy(:,2)*MPH2mps;
v_us06(:,2) = v_us06(:,2)*MPH2mps;
v_udds(:,2) = v_udds(:,2)*MPH2mps;